function [ respTime ] = doPreemption( respTime, period, executionTime )

%integrates the preemption effect of a job
%given the response time at the current stage, and the arrival time distribution of a preempting job and its execution tiem distribution, it outputs the updated response time


intermediaryResults=[];
for i=1:length(period(1,:))
     
    preemption=period(:,i);
    preemptionvalue=preemption(1,1);
    preemptionpercent=preemption(2,1);
    fake=[0; preemptionpercent];
    
    [head,tail]=constructHeadTail(respTime,preemptionvalue);
    
    
    if isempty(tail)
        varinter1=[];
    else
        varinter1=dcf(tail,executionTime);
    end
    
    concat1 = cat(2,head,varinter1);
    resintermediaire = dcf(fake, concat1);
    intermediaryResults = [intermediaryResults resintermediaire];
       
end

respTime = sortRandVar(intermediaryResults);

end

